Loading...
Searching...
No Matches
BALL::NMRStarFile Class Reference

This class provides methods for reading and assigning chemical shifts. More...

`#include <BALL/FORMAT/NMRStarFile.h>`

Inheritance diagram for BALL::NMRStarFile:

## Classes

class | SampleCondition
class | Sample
class | ShiftReferenceElement
class | ShiftReferenceSet
class | NMRAtomData
class | NMRAtomDataSet
class | EntryInformation
class | MonomericPolymer
class | MolecularSystem
class | NMRSpectrometer
class | BALLToBMRBMapper

## Public Member Functions

Constructors and Destructors
| NMRStarFile ()
| NMRStarFile (const String &file_name, File::OpenMode open_mode=std::ios::in)
| ~NMRStarFile ()
| Destructor.
Access methods
bool | read ()
bool | read (AtomContainer &ac)
bool | assignShifts (BALLToBMRBMapper &ball_to_bmrb_mapping)
bool | assignShifts (AtomContainer &ac, const String &chemical_unit, const String &aligned_ball_sequence, const String &aligned_nmrstar_sequence)
Size | getNumberOfAtoms () const
Size | getNumberOfShiftsAssigned () const
const std::vector< NMRAtomDataSet > & | getNMRData () const
const EntryInformation & | getEntryInformation () const
const MolecularSystem & | getMolecularInformation () const
MolecularSystem & | getMolecularInformation ()
const MolecularSystem::ChemicalUnit & | getChemicalUnitByLabel (String const &label) const
MolecularSystem::ChemicalUnit & | getChemicalUnitByLabel (String const &label)
bool | hasSampleCondition (String name)
bool | hasSampleCondition (String name) const
SampleCondition & | getSampleConditionByName (String name)
const SampleCondition & | getSampleConditionByName (String name) const
SampleCondition & | getSampleCondition (Position i)
| Get the i-th SampleCondition.
const SampleCondition & | getSampleCondition (Position i) const
| Get the i-th SampleCondition.
Size | getNumberOfSampleConditions () const
| Get the number of sample conditions.
const std::vector< SampleCondition > & | getSampleConditions () const
| Get the sample conditions.
std::vector< SampleCondition > & | getSampleConditions ()
| Get the sample conditions.
std::vector< Sample > | getSamples () const
| Get the samples.
Size | getNumberOfSamples () const
| Get the number of samples.
bool | hasSample (String label) const
| Return true if the file contains a sample named label, false otherwise.
Sample | getSample (Position i) const
Sample | getSample (String label) const
std::vector< ShiftReferenceSet > & | getShiftReferenceSets ()
| Get the shift reference sets.
const std::vector< ShiftReferenceSet > & | getShiftReferenceSets () const
| Get the shift reference sets.
Size | getNumberOfShiftReferenceSets () const
| Get the number of shift reference sets.
bool | hasShiftReferenceSet (String name)
| Check if there is a ShiftReferenceSet named name.
ShiftReferenceSet & | getShiftReferenceSet (Position i)
| Get the i-th shift reference set.
const ShiftReferenceSet & | getShiftReferenceSet (Position i) const
| Get the i-th shift reference set.
const ShiftReferenceSet & | getShiftReferenceSetByName (String name) const
| Get a ShiftReferenceSet by its SaveFrame name.
ShiftReferenceSet & | getShiftReferenceSetByName (String name)
| Get a ShiftReferenceSet by its SaveFrame name.
std::vector< NMRSpectrometer > & | getNMRSpectrometers ()
| Get the spectrometers.
const std::vector< NMRSpectrometer > & | getNMRSpectrometers () const
| Get the spectrometers.
Size | getNumberOfNMRSpectrometers () const
| Get the number of nmr spectrometers.
NMRSpectrometer & | getNMRSpectrometer (Position i)
| Get the i-th spectrometer.
const NMRSpectrometer & | getNMRSpectrometer (Position i) const
| Get the i-th spectrometer.
NMRSpectrometer & | getNMRSpectrometerByName (String name)
| Get the spectrometer by its SaveFrame name.
const NMRSpectrometer & | getNMRSpectrometerByName (String name) const
| Get the spectrometer by its SaveFrame name.
String | getNMRSpectrometerManufacturer (Position i) const
| Get the spectrometer manufacturer.
float | getNMRSpectrometerFieldStrength (Position i) const
| Get the spectrometer field strength.
NMRStarFile::MonomericPolymer & | getMonomericPolymer (Position i)
const NMRStarFile::MonomericPolymer & | getMonomericPolymer (Position i) const
NMRStarFile::MonomericPolymer & | getMonomericPolymer (const String &name)
const NMRStarFile::MonomericPolymer & | getMonomericPolymer (const String &name) const
Size | getNumberOfMonomericPolymers () const
| Get the number of monomeric polymers in the file.
vector< MonomericPolymer > | getMonomericPolymers () const
| Get all Monomeric Polymers.
bool | hasMonomericPolymer (String name) const
| Check if polymer name is already stored is a monomeric polymer.
bool | isMonomericPolymer (String chemical_unit_label)
void | addMonomericPolymer (MonomericPolymer mp)
String | getResidueSequence (Position i=0) const
bool | hasHshifts () const
| Check, whether this NMRFile provides hydrogen shifts.
bool | hasCshifts () const
| Check, whether this NMRFile provides carbon shifts.
bool | hasNshifts () const
| Check, whether this NMRFile provides nitrogen shifts.
Public Member Functions inherited from BALL::CIFFile
| CIFFile ()
| CIFFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~CIFFile ()
virtual bool | write ()
void | inSafeframe (const char *name)
void | inItem (const char *name)
void | inDatablock (const char *name)
void | insertDatablock (const Datablock &datablock)
const Datablock & | getDatablock (const String &name) const
Datablock & | getDatablock (const String &name)
bool | hasDatablock (const String &name) const
void | setMolecule (Molecule *molecule)
void | clearParameters ()
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Static Public Attributes

static const float | FLOAT_VALUE_NA
static const int | INT_VALUE_NA
static const Position | POSITION_VALUE_NA
static State | state
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".

## Equality

bool | operator== (const NMRStarFile &f) const
bool | operator!= (const NMRStarFile &f) const
void | clear ()

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
virtual void | initRead_ ()
Molecule * | molecule_
String | current_datablock_
String | current_saveframe_
String | current_item_
StringHashMap< Index > | datablocks_hash_
vector< Datablock > | datablocks_
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

This class provides methods for reading and assigning chemical shifts.

NMRStarFile class.

This class provides methods for reading and assigning experimental chemical shifts from NMRStar files to peptides. The nested class BALLToBMRBMapper creates a mapping between NMRStar file atoms and atoms of a chain either based on a trivial mapping

See also
  createTrivialMapping() or based on a given alignment
  createMapping(). Access to information other than the shifts is provided as well.

Example code:

System system;
pdb_file >> system;
Chain& chain = *(system.beginChain());
NMRStarFile nmr_file("NMRStarFile_test.bmr");
cout << "File contains " << nmr_file.getNumberOfAtoms() << " chemical shifts" << endl;
cout << "Number of samples: " << nmr_file.getNumberOfSamples() << endl;
NMRStarFile::MolecularSystem nmr_mol_sys = nmr_file.getMolecularInformation();
cout << "Molecular systems name: " << nmr_mol_sys.system_name << endl;
cout << "Number of possible chemical units: " << nmr_mol_sys.getNumberOfChemicalUnits() << endl;
// the chemical units of this file
for (Size k=0; k < nmr_mol_sys.getNumberOfChemicalUnits(); k++)
{
NMRStarFile::MolecularSystem::ChemicalUnit cu = nmr_mol_sys.getChemicalUnit(k);
cout << " " << k << " : " << cu.component_name
<< " " << cu.label << endl;
}
// get the shift data
// NOTE: nmr_file.atom_data_sets_ equals nmr_data !
std::vector<NMRStarFile::NMRAtomDataSet> const& nmr_data = nmr_file.getNMRData();
cout << "Number of shift sets: " << nmr_data.size() << endl;
for (Size k=0; k < nmr_data.size(); k++)
{
cout << " " << k << " shift set name: " << nmr_data[k].name << " -- condition name: " << nmr_data[k].condition << endl;
}
// decide for a chemical unit
NMRStarFile::MolecularSystem::ChemicalUnit cu = nmr_mol_sys.getChemicalUnit(0);
String chemical_unit_label = cu.label;
cout << Peptides::GetSequence(chain) << endl;
cout << nmr_file.getResidueSequence() << endl;
// create a mapping based on an alignment
cout << "Create a mapping... " ;
NMRStarFile::BALLToBMRBMapper mapper(chain, nmr_file, chemical_unit_label);
mapper.createMapping("MKSTGIVRKVDELGR-VVIPIELRRTLGIAEKDALEIYVDDEKIILKKYKPNMT",
"MKSTGIVRKVDELGRVV-IPIELRRTLGIAEKDALEIYVDDEKIILKKYKPNMT");
cout << "Number of mismatches: " << mapper.getNumberOfMismatches() << endl;
cout << "Number of gaps: " << mapper.getNumberOfGaps() << endl;
// assign the shifts
nmr_file.assignShifts(mapper);
cout << "Assigned " << nmr_file.getNumberOfShiftsAssigned()
<< " shifts given " << nmr_file.getNumberOfAtoms() << " chemical shifts." << endl << endl;
...
cout << atom->getProperty(ShiftModule::PROPERTY__EXPERIMENTAL__SHIFT).getFloat() << endl;
...
// get the ChemicalUnit by label
NMRStarFile::MolecularSystem::ChemicalUnit chemical_unit = getChemicalUnitByLabel(chemical_unit_label);
// find the corresponding SampleCondition
if (chemical_unit.shifts && nmr_file.hasSampleCondition(chemical_unit.shifts->condition))
{
NMRStarFile::SampleCondition& condition = nmr_file.getSampleConditionByName(chemical_unit.shifts->condition);
if (condition.hasType("pH"))
pH = condition.values["pH"];
if (condition.hasType("pH*"))
pH = condition.values["pH*"];
if (condition.hasType("temperature"))
temperature = condition.values["temperature"];
if (condition.hasType("pressure"))
pressure = condition.values["pressure"];
cout << "NMR conditions: " << pH << ", " << temperature << ", " << pressure << endl;
}
BALL::Chain
Definition chain.h:32
BALL::NMRStarFile::MolecularSystem::ChemicalUnit
Definition NMRStarFile.h:383
BALL::NMRStarFile::MolecularSystem::ChemicalUnit::component_name
String component_name
Definition NMRStarFile.h:389
BALL::NMRStarFile::MolecularSystem::ChemicalUnit::label
String label
Definition NMRStarFile.h:390
BALL::NMRStarFile::MolecularSystem
Definition NMRStarFile.h:362
BALL::NMRStarFile::MolecularSystem::getChemicalUnit
ChemicalUnit const & getChemicalUnit(Position i) const
Definition NMRStarFile.h:399
BALL::NMRStarFile::MolecularSystem::getNumberOfChemicalUnits
Size getNumberOfChemicalUnits() const
Definition NMRStarFile.h:402
BALL::NMRStarFile::MolecularSystem::system_name
String system_name
Definition NMRStarFile.h:405
BALL::NMRStarFile::NMRStarFile
NMRStarFile()
BALL::NMRStarFile::getChemicalUnitByLabel
const MolecularSystem::ChemicalUnit & getChemicalUnitByLabel(String const &label) const
BALL::ShiftModule::PROPERTY__EXPERIMENTAL__SHIFT
static const char * PROPERTY__EXPERIMENTAL__SHIFT
Definition shiftModule.h:59
BALL::System
Definition KERNEL/system.h:40
BALL::Peptides::GetSequence
BALL_EXPORT OneLetterAASequence GetSequence(const Protein &protein)
BALL::Size
BALL_SIZE_TYPE Size
Definition COMMON/global.h:114

Definition at line 113 of file NMRStarFile.h.

## Constructor & Destructor Documentation

## NMRStarFile() [1/2]

BALL::NMRStarFile::NMRStarFile | ( |  | ) |

Standard constructor

## NMRStarFile() [2/2]

BALL::NMRStarFile::NMRStarFile | ( | const String & | file_name,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constuctor. Opens the given file and extracts all usefull data (Calls read ).

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~NMRStarFile()

BALL::NMRStarFile::~NMRStarFile | ( |  | ) |

Destructor.

## Member Function Documentation

## addMonomericPolymer()

void BALL::NMRStarFile::addMonomericPolymer | ( | MonomericPolymer | mp | ) |

Add a Monomeric Polymer NOTE: if a poymer with the same name already exists, it will be overwritten!

## assignShifts() [1/2]

bool BALL::NMRStarFile::assignShifts | ( | AtomContainer & | ac,
|  | const String & | chemical_unit,
|  | const String & | aligned_ball_sequence,
|  | const String & | aligned_nmrstar_sequence )

Assign the shifts to the given AtomContainer as pointed out in the alignment. The alignmed sequences should be given in OneLetterCode, where '-' denotes a gap.

Parameters

  ac | AtomContainer to which the NMRStarfile's shift should be assigned.
  chemical_unit | the name of the molecular system (chemical unit) storing the atom shifts
  aligned_ball_sequence | the aligned AtomContainers aminoacid sequence
  aligned_nmrstar_sequence | the aligned aminoacid sequence of the NMRStar file atoms

Returns
  bool - true if reading the file was successful

## assignShifts() [2/2]

bool BALL::NMRStarFile::assignShifts | ( | BALLToBMRBMapper & | ball_to_bmrb_mapping | ) |

Assign the shifts to the given AtomContainer as denoted in the given {BALLToBMRBMapper}.

Returns
  bool - true if reading the file was successful

See also
  NMRStarFile::BALLToBMRBMapper

## clear()

void BALL::NMRStarFile::clear | ( |  | ) |

virtual

Clear the object.

Reimplemented from BALL::File.

## getChemicalUnitByLabel() [1/2]

MolecularSystem::ChemicalUnit & BALL::NMRStarFile::getChemicalUnitByLabel | ( | String const & | label | ) |

Get a chemical unit by name

## getChemicalUnitByLabel() [2/2]

const MolecularSystem::ChemicalUnit & BALL::NMRStarFile::getChemicalUnitByLabel | ( | String const & | label | ) | const

Get a chemical unit by name

## getEntryInformation()

const EntryInformation & BALL::NMRStarFile::getEntryInformation | ( |  | ) | const

inline

Get the entry information

Definition at line 678 of file NMRStarFile.h.

## getMolecularInformation() [1/2]

MolecularSystem & BALL::NMRStarFile::getMolecularInformation | ( |  | ) |

inline

Get the molecular information

Definition at line 686 of file NMRStarFile.h.

## getMolecularInformation() [2/2]

const MolecularSystem & BALL::NMRStarFile::getMolecularInformation | ( |  | ) | const

inline

Get the molecular information

Definition at line 682 of file NMRStarFile.h.

## getMonomericPolymer() [1/4]

NMRStarFile::MonomericPolymer & BALL::NMRStarFile::getMonomericPolymer | ( | const String & | name | ) |

Get a mutable reference to the MonomericPolymer-information by name

Exceptions

  Exception::OutOfRange | if a polymer with this name could not be found

## getMonomericPolymer() [2/4]

const NMRStarFile::MonomericPolymer & BALL::NMRStarFile::getMonomericPolymer | ( | const String & | name | ) | const

Get the MonomericPolymer-information by name

Exceptions

  Exception::OutOfRange | if a polymer with this name could not be found

## getMonomericPolymer() [3/4]

NMRStarFile::MonomericPolymer & BALL::NMRStarFile::getMonomericPolymer | ( | Position | i | ) |

Get a mutable reference to the MonomericPolymer-information by index

Exceptions

  Exception::OutOfRange | if a polymer with this index could not be found

## getMonomericPolymer() [4/4]

const NMRStarFile::MonomericPolymer & BALL::NMRStarFile::getMonomericPolymer | ( | Position | i | ) | const

Get the MonomericPolymer-information by index

Exceptions

  Exception::OutOfRange | if a polymer with this index could not be found

## getMonomericPolymers()

vector< MonomericPolymer > BALL::NMRStarFile::getMonomericPolymers | ( |  | ) | const

inline

Get all Monomeric Polymers.

Definition at line 822 of file NMRStarFile.h.

## getNMRData()

const std::vector< NMRAtomDataSet > & BALL::NMRStarFile::getNMRData | ( |  | ) | const

Get the extracted data for the atoms

## getNMRSpectrometer() [1/2]

NMRSpectrometer & BALL::NMRStarFile::getNMRSpectrometer | ( | Position | i | ) |

Get the i-th spectrometer.

## getNMRSpectrometer() [2/2]

const NMRSpectrometer & BALL::NMRStarFile::getNMRSpectrometer | ( | Position | i | ) | const

Get the i-th spectrometer.

## getNMRSpectrometerByName() [1/2]

NMRSpectrometer & BALL::NMRStarFile::getNMRSpectrometerByName | ( | String | name | ) |

Get the spectrometer by its SaveFrame name.

## getNMRSpectrometerByName() [2/2]

const NMRSpectrometer & BALL::NMRStarFile::getNMRSpectrometerByName | ( | String | name | ) | const

Get the spectrometer by its SaveFrame name.

## getNMRSpectrometerFieldStrength()

float BALL::NMRStarFile::getNMRSpectrometerFieldStrength | ( | Position | i | ) | const

Get the spectrometer field strength.

## getNMRSpectrometerManufacturer()

String BALL::NMRStarFile::getNMRSpectrometerManufacturer | ( | Position | i | ) | const

Get the spectrometer manufacturer.

## getNMRSpectrometers() [1/2]

std::vector< NMRSpectrometer > & BALL::NMRStarFile::getNMRSpectrometers | ( |  | ) |

inline

Get the spectrometers.

Definition at line 774 of file NMRStarFile.h.

## getNMRSpectrometers() [2/2]

const std::vector< NMRSpectrometer > & BALL::NMRStarFile::getNMRSpectrometers | ( |  | ) | const

inline

Get the spectrometers.

Definition at line 776 of file NMRStarFile.h.

## getNumberOfAtoms()

Size BALL::NMRStarFile::getNumberOfAtoms | ( |  | ) | const

Return the maximum number of atoms in all shift sets

## getNumberOfMonomericPolymers()

Size BALL::NMRStarFile::getNumberOfMonomericPolymers | ( |  | ) | const

inline

Get the number of monomeric polymers in the file.

Definition at line 819 of file NMRStarFile.h.

## getNumberOfNMRSpectrometers()

Size BALL::NMRStarFile::getNumberOfNMRSpectrometers | ( |  | ) | const

inline

Get the number of nmr spectrometers.

Definition at line 779 of file NMRStarFile.h.

## getNumberOfSampleConditions()

Size BALL::NMRStarFile::getNumberOfSampleConditions | ( |  | ) | const

inline

Get the number of sample conditions.

Definition at line 721 of file NMRStarFile.h.

## getNumberOfSamples()

Size BALL::NMRStarFile::getNumberOfSamples | ( |  | ) | const

inline

Get the number of samples.

Definition at line 736 of file NMRStarFile.h.

## getNumberOfShiftReferenceSets()

Size BALL::NMRStarFile::getNumberOfShiftReferenceSets | ( |  | ) | const

inline

Get the number of shift reference sets.

Definition at line 757 of file NMRStarFile.h.

## getNumberOfShiftsAssigned()

Size BALL::NMRStarFile::getNumberOfShiftsAssigned | ( |  | ) | const

inline

Return the number of atoms assigned a chemical shift

Definition at line 670 of file NMRStarFile.h.

## getResidueSequence()

String BALL::NMRStarFile::getResidueSequence | ( | Position | i = 0 | ) | const

Get the sequence of residues of the i-th monomeric polymer in the file.

This method automatically compares the i-th monomeric_polymers' residue sequence with the actual stored NMR shift data. If there is a mismatch, a warning is given! If there is a mismatch or there is no monomeric_polymers residue sequence an empty.

Returns
  String amino acid sequence

## getSample() [1/2]

Sample BALL::NMRStarFile::getSample | ( | Position | i | ) | const

Get the i-th sample. If i is out of size a dummy sample is returned.

## getSample() [2/2]

Sample BALL::NMRStarFile::getSample | ( | String | label | ) | const

Get the sample with name label. If no sample with name label exist a dummy sample is returned.

## getSampleCondition() [1/2]

SampleCondition & BALL::NMRStarFile::getSampleCondition | ( | Position | i | ) |

inline

Get the i-th SampleCondition.

Definition at line 715 of file NMRStarFile.h.

## getSampleCondition() [2/2]

const SampleCondition & BALL::NMRStarFile::getSampleCondition | ( | Position | i | ) | const

inline

Get the i-th SampleCondition.

Definition at line 718 of file NMRStarFile.h.

## getSampleConditionByName() [1/2]

SampleCondition & BALL::NMRStarFile::getSampleConditionByName | ( | String | name | ) |

Get a SampleCondition by its SaveFrame name

## getSampleConditionByName() [2/2]

const SampleCondition & BALL::NMRStarFile::getSampleConditionByName | ( | String | name | ) | const

Get a SampleCondition by its SaveFrame name

## getSampleConditions() [1/2]

std::vector< SampleCondition > & BALL::NMRStarFile::getSampleConditions | ( |  | ) |

inline

Get the sample conditions.

Definition at line 727 of file NMRStarFile.h.

## getSampleConditions() [2/2]

const std::vector< SampleCondition > & BALL::NMRStarFile::getSampleConditions | ( |  | ) | const

inline

Get the sample conditions.

Definition at line 724 of file NMRStarFile.h.

## getSamples()

std::vector< Sample > BALL::NMRStarFile::getSamples | ( |  | ) | const

inline

Get the samples.

Definition at line 732 of file NMRStarFile.h.

## getShiftReferenceSet() [1/2]

ShiftReferenceSet & BALL::NMRStarFile::getShiftReferenceSet | ( | Position | i | ) |

inline

Get the i-th shift reference set.

Definition at line 763 of file NMRStarFile.h.

## getShiftReferenceSet() [2/2]

const ShiftReferenceSet & BALL::NMRStarFile::getShiftReferenceSet | ( | Position | i | ) | const

inline

Get the i-th shift reference set.

Definition at line 765 of file NMRStarFile.h.

## getShiftReferenceSetByName() [1/2]

ShiftReferenceSet & BALL::NMRStarFile::getShiftReferenceSetByName | ( | String | name | ) |

Get a ShiftReferenceSet by its SaveFrame name.

## getShiftReferenceSetByName() [2/2]

const ShiftReferenceSet & BALL::NMRStarFile::getShiftReferenceSetByName | ( | String | name | ) | const

Get a ShiftReferenceSet by its SaveFrame name.

## getShiftReferenceSets() [1/2]

std::vector< ShiftReferenceSet > & BALL::NMRStarFile::getShiftReferenceSets | ( |  | ) |

inline

Get the shift reference sets.

Definition at line 752 of file NMRStarFile.h.

## getShiftReferenceSets() [2/2]

const std::vector< ShiftReferenceSet > & BALL::NMRStarFile::getShiftReferenceSets | ( |  | ) | const

inline

Get the shift reference sets.

Definition at line 754 of file NMRStarFile.h.

## hasCshifts()

bool BALL::NMRStarFile::hasCshifts | ( |  | ) | const

inline

Check, whether this NMRFile provides carbon shifts.

Definition at line 855 of file NMRStarFile.h.

## hasHshifts()

bool BALL::NMRStarFile::hasHshifts | ( |  | ) | const

inline

Check, whether this NMRFile provides hydrogen shifts.

Definition at line 852 of file NMRStarFile.h.

## hasMonomericPolymer()

bool BALL::NMRStarFile::hasMonomericPolymer | ( | String | name | ) | const

Check if polymer name is already stored is a monomeric polymer.

## hasNshifts()

bool BALL::NMRStarFile::hasNshifts | ( |  | ) | const

inline

Check, whether this NMRFile provides nitrogen shifts.

Definition at line 858 of file NMRStarFile.h.

## hasSample()

bool BALL::NMRStarFile::hasSample | ( | String | label | ) | const

Return true if the file contains a sample named label, false otherwise.

## hasSampleCondition() [1/2]

bool BALL::NMRStarFile::hasSampleCondition | ( | String | name | ) |

Return true if the file contains a SampleCondition named name, false otherwise

## hasSampleCondition() [2/2]

bool BALL::NMRStarFile::hasSampleCondition | ( | String | name | ) | const

Return true if the file contains a SampleCondition named name, false otherwise

## hasShiftReferenceSet()

bool BALL::NMRStarFile::hasShiftReferenceSet | ( | String | name | ) |

Check if there is a ShiftReferenceSet named name.

## isMonomericPolymer()

bool BALL::NMRStarFile::isMonomericPolymer | ( | String | chemical_unit_label | ) |

Check if label is a monomeric polymer.

Returns true if a monomer with name chemical_unit_label exists, false otherwise.

## operator!=()

bool BALL::NMRStarFile::operator!= | ( | const NMRStarFile & | f | ) | const

Inequality operator Test if both instances point to different files.

## operator==()

bool BALL::NMRStarFile::operator== | ( | const NMRStarFile & | f | ) | const

Equality operator. Test if both instances point to the same file.

## read() [1/2]

bool BALL::NMRStarFile::read | ( |  | ) |

virtual

Read an NMRStarFile.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::CIFFile.

## read() [2/2]

bool BALL::NMRStarFile::read | ( | AtomContainer & | ac | ) |

## Member Data Documentation

## FLOAT_VALUE_NA

const float BALL::NMRStarFile::FLOAT_VALUE_NA

static

Definition at line 119 of file NMRStarFile.h.

## INT_VALUE_NA

const int BALL::NMRStarFile::INT_VALUE_NA

static

Definition at line 120 of file NMRStarFile.h.

## POSITION_VALUE_NA

const Position BALL::NMRStarFile::POSITION_VALUE_NA

static

Definition at line 122 of file NMRStarFile.h.